//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
// - gRabbit Animation Iterator Class (interface)
//
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_ANIMATION_ITERATOR_H_
#define __GRABBIT_ANIMATION_ITERATOR_H_

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_instructions.h"

// C++ includes
#include <stack>
#include <list>

//----------------------------------------------------------------------------------------------------------------------
// Class Definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitAnimationIterator {
 public:
  GrabbitAnimationIterator();
  ~GrabbitAnimationIterator();
  
  // Methods
  GrabbitInstructions *GetNextInstruction();
  GrabbitInstructions *GetActualInstruction();
  GrabbitInstructions *Undo();
  
  // Manipulation
  void InsertIntruction(GrabbitInstructions *grb);
  void InsertUndoIntruction(GrabbitInstructions *grb);
  void ClearInstructions();
  void Restart();
  void Initialize();
  
  // Information
  unsigned long Size();
  bool GetCicle();
  
 private:
  std::list < GrabbitInstructions * > instructions;
  std::stack < GrabbitInstructions * > undo;
  GrabbitInstructions *actual;
  bool cicle;
};

#endif
