//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
// - Animation Files Parser
//
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_ANIMATION_PARSER_H_
#define __GRABBIT_ANIMATION_PARSER_H_

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_animation_iterator.h"

// C++ Includes
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cctype>
#include <cstring>


//----------------------------------------------------------------------------------------------------------------------
// Class Definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitAnimationParser {
 public:
  GrabbitAnimationParser(const wxString &filename);
  ~GrabbitAnimationParser();
  
  // Methods
  bool Open(const wxString &filename);
  bool CheckOpened();
  bool CheckEOF();
  int CheckError();
  void ReadInstruction(GrabbitAnimationIterator *it);
  void GetError(wxString &err);
  
 private:
  // Private Methods
  void JumpWhiteSpaces();
  void ReadStr();
  void ReadStrQuote();
  void ReadNumber();
  void ReadComma();
  void ReadSemicolon();
  void ReadOpenParenthesis();
  void ReadCloseParenthesis();
  void ReadRGB(unsigned char &r, unsigned char &g, unsigned char &b);
  void SetError(int errrr, unsigned long line=0);

  // Members
  std::ifstream file;
  unsigned long lines;
  int state, errornumber, errorline;
  char c;
  bool haseof;
  wxString token;
  wxString errmessage;
};

#endif
