//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - Main class: All starts here!
// 
//----------------------------------------------------------------------------------------------------------------------
#ifdef __GNUG__
  #pragma implementation
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_app.h"
#include "grabbit_main_frame.h"

#include "wx/tooltip.h"

IMPLEMENT_APP(Grabbit);

//----------------------------------------------------------------------------------------------------------------------  
// Initialization Function. This is where the program starts.
//----------------------------------------------------------------------------------------------------------------------
bool Grabbit::OnInit() {
  // Initialize the colour database
  wxTheColourDatabase->Initialize();
    
  // Create the main frame window
  GrabbitMainFrame *frame = new GrabbitMainFrame((wxFrame  *) NULL, _T("gRabbit"),
						 10, 50, 450, 340);

  // Tooltips
  wxToolTip::Enable(true);
  wxToolTip::SetDelay(500);
  
  // activate it
  frame->Show(true);
  SetTopWindow(frame);
  frame->Refresh(false); // Give the impression of giving coconut water to the window ;-)
  return true;
}

//----------------------------------------------------------------------------------------------------------------------  
// Finalization Function. This is where the world ends! Bwahahahahaha......
//----------------------------------------------------------------------------------------------------------------------
int Grabbit::OnExit()
{
  return (0);
}
