//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - GrabbitBasicShape: Abstract class for building shapes (implementation)
// 
//----------------------------------------------------------------------------------------------------------------------
#ifdef __GNUG__
  #pragma implementation
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_basic_shape.h"

//----------------------------------------------------------------------------------------------------------------------
// Default Background Colour (WHITE)
//----------------------------------------------------------------------------------------------------------------------
wxColour GrabbitBasicShape::bg_colour = wxColor(255,255,255);

//----------------------------------------------------------------------------------------------------------------------
// Draw: Used for all shapes, it just blits the shape to the dc parameter.
//----------------------------------------------------------------------------------------------------------------------
void GrabbitBasicShape::Draw(wxDC& dc) {
  wxMemoryDC mem;
  mem.SelectObject( this->shape_bmp );
  dc.Blit(shape_pos.x, shape_pos.y, shape_tam.GetWidth(), shape_tam.GetHeight(), &mem, 0, 0, wxCOPY, true);
  mem.SelectObject( wxNullBitmap );
}
