//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - GrabbitConfigurator: An object to handle global configurations (interface).
// 
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_CONFIGURATOR_H_
#define __GRABBIT_CONFIGURATOR_H_

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"


//----------------------------------------------------------------------------------------------------------------------
// Class definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitConfigurator
{
 public:
  GrabbitConfigurator();

  // Get Methods
  wxColour GetDrawAreaBgColor() const { return DrawAreaBgColour; }
  
  // Set Methods
  void SetDrawAreaBgColor(const wxColour &bg) { DrawAreaBgColour = bg; }
  
 private:
  wxColour DrawAreaBgColour;
  
};


#endif
