//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - Geometric Predicates (implementation)
// 
//----------------------------------------------------------------------------------------------------------------------
#ifdef __GNUG__
  #pragma implementation
#endif

#include "grabbit_common.h"

//----------------------------------------------------------------------------------------------------------------------
// PREDICATE Area2: returns two times the signaled area of the triangle determined by the points p1, p2 and p3.
//----------------------------------------------------------------------------------------------------------------------
long Area2(const wxPoint &p1, const wxPoint &p2, const wxPoint &p3)
{
  return p1.x * p2.y - p1.y * p2.x + p1.y * p3.x - p1.x * p3.y + p2.x * p3.y - p3.x * p2.y;
}

//----------------------------------------------------------------------------------------------------------------------
// PREDICATE Collinear: returns true if the points p1, p2 and p3 are at the same line. Returns false otherwise
//----------------------------------------------------------------------------------------------------------------------
bool Collinear(const wxPoint &p1, const wxPoint &p2, const wxPoint &p3)
{
  return Area2(p1, p2, p3) == 0;
}
