//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - GrabbitGraph: A class to represent a Graph (interface)
// 
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_GRAPH_H_
#define __GRABBIT_GRAPH_H_

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"


//----------------------------------------------------------------------------------------------------------------------
// Class definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitGraph {
 public:
  GrabbitGraph();
  ~GrabbitGraph();

  // Set Methods
  void SetDirected(bool val) { directed = val; }
  void SetVertex(const unsigned long v) { vertex = v; }
  void SetLines(const unsigned long l) { lines = l; }
  
  
  // Get Methods
  bool GetDirected() const { return directed; }
  unsigned long GetVertex() const { return vertex; }
  unsigned long GetLines() const { return lines; }
  
  
 private:
  bool directed;
  unsigned long vertex, lines;
  
};

#endif
