//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
// - Main Animatio Panel class (interface)
//
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_MAIN_ANIMATION_PANEL_H__
#define __GRABBIT_MAIN_ANIMATION_PANEL_H__

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_config.h"

// External code
#include "toggle.h"

// C++ Library includes
#include <vector>


//----------------------------------------------------------------------------------------------------------------------
// Class Definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitMainAnimationPanel : public wxPanel
{
 public:
  GrabbitMainAnimationPanel(wxWindow *main);
  ~GrabbitMainAnimationPanel();

  // Others
  unsigned int GetSelected() { return selected; }
  //wxCustomButton *GetButtonById(unsigned int num);
  void DepressButtonById(unsigned int num, bool flag);
  void OnResize(wxSizeEvent &event);
  void OnSliderUpdate(wxCommandEvent &event);
  
  // Mouse Event Handlers
  void GenericClickButtonResponse(wxCommandEvent& event);

  // Static
  static GrabbitMainAnimationPanel *GetMe() { return instance; }
  
private:
  static GrabbitMainAnimationPanel *instance;
  int selected;
  std::vector< wxCustomButton * > grb_buttons;
  wxSlider *speedBar;
  
  DECLARE_EVENT_TABLE();
};

#endif
