//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
// - Main Button Panel class (interface)
//
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_MAIN_BUTTON_PANEL_H__
#define __GRABBIT_MAIN_BUTTON_PANEL_H__

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_config.h"

// External code
#include "toggle.h"

// C++ Library includes
#include <vector>


//----------------------------------------------------------------------------------------------------------------------
// Class Definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitMainButtonPanel : public wxPanel
{
 public:
  GrabbitMainButtonPanel(wxWindow *main);
  ~GrabbitMainButtonPanel();

  // Others
  unsigned int GetSelected() { return selected; }
  wxCustomButton *GetButtonById(unsigned int num);
  void OnResize(wxSizeEvent &event);

  // Mouse Event Handlers
  void GenericClickButtonResponse(wxCommandEvent& event);

private:
  unsigned int selected;
  std::vector< wxCustomButton * > grb_buttons;

  DECLARE_EVENT_TABLE();
};

#endif
