//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
// - Main Frame class headers
//
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_MAIN_FRAME_H__
#define __GRABBIT_MAIN_FRAME_H__

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_main_button_panel.h"
#include "grabbit_main_scrolled_window.h"
#include "grabbit_configurator.h"
#include "grabbit_main_animation_panel.h"

// External code
#include "toggle.h"

// C++ Library includes
#include <list>
#include <vector>


//----------------------------------------------------------------------------------------------------------------------
// This is the main window of gRabbit
//----------------------------------------------------------------------------------------------------------------------
class GrabbitMainFrame : public wxFrame
{
public:
  // Constructors and Destructors
  GrabbitMainFrame(wxFrame *frame, wxChar *title, int x, int y, int w, int h);
  ~GrabbitMainFrame();

  // Menu Events
  void OnQuit(wxCommandEvent& event);
  void OnLoadProject(wxCommandEvent& event);
  void OnSaveProject(wxCommandEvent& event);
  void OnLoadAnimation(wxCommandEvent& event);
  
  // Window Events
  void OnResize(wxSizeEvent &event);

  // Static methods
  static GrabbitConfigurator *GetConfigurator() { return GrabbitMainFrame::myConfig; }
  static void SetConfigurator(GrabbitConfigurator *config) { GrabbitMainFrame::myConfig = config; }


private:
  static GrabbitConfigurator *myConfig;

  GrabbitMainButtonPanel *button_panel;
  GrabbitMainAnimationPanel *animation_panel;
  GrabbitMainScrolledWindow *scroll_window;

  DECLARE_EVENT_TABLE();
};

#endif
