//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - GrabbitShapeArc: An Arc Class for gRabbit (interface)
// 
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_SHAPE_ARC_H_
#define __GRABBIT_SHAPE_ARC_H_

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_shape_line.h"
#include "grabbit_shape_vertex.h"


//----------------------------------------------------------------------------------------------------------------------
// Class Definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitShapeArc : public GrabbitShapeLine
{
 public:
  GrabbitShapeArc(const wxString& ll);
  ~GrabbitShapeArc() { }
  
  // Interface
  void RefreshImage() { }
  void Draw(wxDC& dc);
  void Highlight();
  
  const wxString& GetLabel() { return label; }
  
 private:
  static unsigned long created;
};


#endif
