//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - GrabbitShapeLine: An Line Shape for gRabbit (implementation)
// 
//----------------------------------------------------------------------------------------------------------------------
#ifdef __GNUG__
  #pragma implementation
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_shape_line.h"
#include "grabbit_geo_predicates.h"
#include "grabbit_shape_vertex.h"

//----------------------------------------------------------------------------------------------------------------------
// Returns true if (x,y) is a point in the line
//----------------------------------------------------------------------------------------------------------------------
bool GrabbitShapeLine::GotInside(long x, long y) const
{
  return Collinear( v1->GetPosition(), v1->GetPosition(), wxPoint(x,y) );
}

//----------------------------------------------------------------------------------------------------------------------
// Draw this line on the selected DC
//----------------------------------------------------------------------------------------------------------------------
void GrabbitShapeLine::Draw(wxDC& dc)
{
  dc.SetPen( wxPen(*wxBLACK, 1, wxSOLID) );
  dc.DrawLine((v1->GetCentre()).x, (v1->GetCentre()).y, (v2->GetCentre()).x, (v2->GetCentre()).y);
}

//----------------------------------------------------------------------------------------------------------------------
// Not used
//----------------------------------------------------------------------------------------------------------------------
void GrabbitShapeLine::RefreshImage()
{
}
