//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - GrabbitShapeLine: An Line Shape for gRabbit (interface)
// 
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_SHAPE_LINE_H_
#define __GRABBIT_SHAPE_LINE_H_

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_basic_shape.h"


//----------------------------------------------------------------------------------------------------------------------
// Class Definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitShapeLine : public GrabbitBasicShape
{
 public:
  GrabbitShapeLine() :
    GrabbitBasicShape(wxDefaultPosition, wxDefaultSize, wxColour(0, 0, 0)) {
    v1 = v2 = NULL;
  }
  GrabbitShapeLine(GrabbitBasicShape *_v1, GrabbitBasicShape *_v2) :
    GrabbitBasicShape(wxDefaultPosition, wxDefaultSize, wxColour(0, 0, 0)) {
    this->v1 = _v1;
    this->v2 = _v2;
  }
  ~GrabbitShapeLine() { }
  
  // Interface
  bool GotInside(long x, long y) const;
  void RefreshImage();
  void Draw(wxDC& dc);

  // Get methods
  GrabbitBasicShape *GetVertex1() { return v1; }
  GrabbitBasicShape *GetVertex2() { return v2; }

  // Set methods
  void SetVertex1(GrabbitBasicShape *_v1) { v1 = _v1; }
  void SetVertex2(GrabbitBasicShape *_v2) { v2 = _v2; }
  
  
 protected:
  GrabbitBasicShape *v1;
  GrabbitBasicShape *v2;

};


#endif
