//----------------------------------------------------------------------------------------------------------------------
//
//  gRabbit - Graph Builder for Basic Implementation Tests
//  Copyright 2004, Nelson Guedes Paulo Junior (npaulo@linux.ime.usp.br)
//
//  Under gRabbit license (see LICENSE.TXT for details)
//
//
//  - GrabbitShapeVertex: A Node Shape for gRabbit
// 
//----------------------------------------------------------------------------------------------------------------------
#ifndef __GRABBIT_SHAPE_NODE_H_
#define __GRABBIT_SHAPE_NODE_H_

#ifdef __GNUG__
  #pragma interface
#endif

// gRabbit includes
#include "grabbit_common.h"
#include "grabbit_shape_line.h"

// C++ includes
#include <list>

// Defines
#define NODE_DEFAULT_RADIUS 11
#define NODE_DEFAULT_SIZE 21

class GrabbitBasicShape;

//----------------------------------------------------------------------------------------------------------------------
// Class Definition
//----------------------------------------------------------------------------------------------------------------------
class GrabbitShapeVertex : public GrabbitBasicShape
{
 public:
  GrabbitShapeVertex(const wxPoint &pos, const wxSize &tam, const wxColour &col);
  GrabbitShapeVertex(const wxPoint &pos, const wxSize &tam, const wxColour &col, const wxString &ll);
  ~GrabbitShapeVertex();
  
  // Interface
  bool GotInside(long x, long y) const;
  void RefreshImage();
  void Highlight();
  
  // maniputale adjacences list
  void AddLine(GrabbitShapeLine *line);
  bool RemoveLine (GrabbitShapeLine *line);
  bool BelongsTo(GrabbitShapeLine *line);
  
 private:
  std::list< GrabbitShapeLine * > adjacency;
  static unsigned long created;
};


#endif
